<?php
// Sécurité
define('OK',1);
// Configuration
include('config.php');
// Fonctions
include('fonctions.php');

//////////////////
// Autorisation //
//////////////////

// Accès aux professeurs connectés uniquement
$mysqli = connectsql();
if ( !$autorisation )  {
  $titre = 'Modification des matières';
  $actuel = false;
  include('login.php');
}
elseif ( $autorisation < 4 )  {
  debut($mysqli,'Modification des matières','Vous n\'avez pas accès à cette page.',$autorisation,' ');
  $mysqli->close();
  fin();
}

//////////////
//// HTML ////
//////////////
debut($mysqli,'Modification des matières',$message,4,'matieres');
echo <<<FIN

  <a class="icon-aide general" data-id="page" title="Aide pour les modifications des matières"></a>
  <a class="icon-ajoute general" data-id="ajoute" title="Ajouter une nouvelle matière"></a>

FIN;
$select_protection = '
        <option value="0">Visible de tous</option>
        <option value="1">Visible pour les connectés</option>
        <option value="2">Visible pour les élèves, colleurs, profs</option>
        <option value="3">Visible pour les colleurs et les profs</option>
        <option value="4">Visible pour les profs uniquement</option>';

// Récupération
$resultat = $mysqli->query("SELECT m.id, ordre, cle, m.nom, colles, cdt, docs, notes, colles_protection, cdt_protection, FIND_IN_SET(m.id,'${_SESSION['matieres']}') AS modifiable,
                            COUNT(IF(u.autorisation=4,1,NULL)) AS np, COUNT(IF(u.autorisation=3,1,NULL)) AS nc, COUNT(IF(u.autorisation=2,1,NULL)) AS ne, COUNT(IF(u.autorisation=1,1,NULL)) AS ni,
                            GROUP_CONCAT(u.id) AS uid
                            FROM matieres AS m LEFT JOIN utilisateurs AS u ON ( FIND_IN_SET(m.id,u.matieres) OR u.matieres='0') AND LENGTH(u.mdp)=40 GROUP BY m.id ORDER BY ordre");
$max = $resultat->num_rows;
function s($n)  { return ( $n > 1 ) ? 's' : ''; }
while ( $r = $resultat->fetch_assoc() )  {
  $id = $r['id'];
  $monte = ( $r['ordre'] == 1 ) ? ' style="display:none;"' : '';
  $descend = ( $r['ordre'] == $max ) ? ' style="display:none;"' : '';
  $sel_colles = str_replace("\"${r['colles_protection']}\"","\"${r['colles_protection']}\" selected",$select_protection);
  $sel_cdt = str_replace("\"${r['cdt_protection']}\"","\"${r['cdt_protection']}\" selected",$select_protection);
  $disabled = $boutons = '';
  if ( $r['modifiable'] )  {
    $suppr = "\n  <a class=\"icon-supprime\" title=\"Supprimer cette matière\"></a>";
    $ok = "\n  <a class=\"icon-ok\" title=\"Valider les modifications\"></a>";
    $indication = '';
    if ( $r['colles'] )
      $boutons .= "\n    <input type=\"button\" class=\"ligne supprmultiple\" data-id=\"matieres|$id|colles\" value=\"Supprimer tous les programmes de colles\">";
    if ( $r['cdt'] )
      $boutons .= "\n    <input type=\"button\" class=\"ligne supprmultiple\" data-id=\"matieres|$id|cdt\" value=\"Supprimer tout le cahier de texte\">";
    if ( $r['docs'] )
      $boutons .= "\n    <input type=\"button\" class=\"ligne supprmultiple\" data-id=\"matieres|$id|docs\" value=\"Supprimer tous les répertoires et documents\">";
    if ( $r['notes'] )
      $boutons .= "\n    <input type=\"button\" class=\"ligne supprmultiple\" data-id=\"matieres|$id|notes\" value=\"Supprimer toutes les notes\">";
  }
  else  {
    $suppr = $ok = '';
    $indication = "\n    <p>Vous ne pouvez pas modifier cette matière tant qu'elle ne vous est pas associée.</p>";
    $disabled = ' disabled';
  }
  if ( $max == 1 )  {
    $suppr = '';
    $indication = '';
  }
  $np = $r['np']; $nc = $r['nc']; $ne = $r['ne']; $ni = $r['ni'];
  if ( $n = $np+$nc+$ne+$ni )  {
    $utilisateurs = '';
    if ( $np )  $utilisateurs .= ", $np professeur".s($np);
    if ( $nc )  $utilisateurs .= ", $nc colleur".s($nc);
    if ( $ne )  $utilisateurs .= ", $ne élève".s($ne);
    if ( $ni )  $utilisateurs .= ", $ni invité".s($ni);
    $utilisateurs = "concerne $n utilisateur".s($n).' dont'.substr($utilisateurs,1);
  }
  else
    $utilisateurs = 'ne concerne aucun utilisateur'; 
  echo <<<FIN

<article data-id="matieres|$id">
  <a class="icon-aide" data-id="matiere" title="Aide pour l'édition de cette matière"></a>
  <a class="icon-monte"$monte title="Déplacer cette matière vers le haut"></a>
  <a class="icon-descend"$descend title="Déplacer cette matière vers le bas"></a>$suppr
  <form>$ok
    <h3 class="edition">${r['nom']}</h3>$indication
    <p class="ligne"><label for="nom$id">Nom complet&nbsp;: </label><input type="text" id="nom$id" name="nom" value="${r['nom']}" size="50"$disabled></p>
    <p class="ligne"><label for="cle$id">Clé dans l'adresse&nbsp;: </label><input type="text" id="cle$id" name="cle" value="${r['cle']}" size="30"$disabled></p>
    <p class="ligne"><label for="colles_protection$id">Accès aux programmes de colles&nbsp;: </label>
      <select id="colles_protection$id" name="colles_protection"$disabled>$sel_colles
      </select>
    </p>
    <p class="ligne"><label for="cdt_protection$id">Accès au cahier de texte&nbsp;: </label>
      <select id="cdt_protection$id" name="cdt_protection"$disabled>$sel_cdt
      </select>
    </p>
  </form>$boutons
  <p class="usermat"><a class="icon-edite" data-uid="${r['uid']}" data-matiere="${r['nom']}|${r['id']}"></a><span>Cette matière $utilisateurs.</span></p>
</article>

FIN;
}
$resultat->free();

// Récupération de tous les utilisateurs
// Utilisateurs non validés : mdp précédé d'une étoile
// Utilisateur vide pour marquer l'arrêt des créations de compte : mdp vide
$resultat = $mysqli->query('SELECT id, autorisation, IF(LENGTH(nom),CONCAT(nom," ",prenom),CONCAT(login," (identifiant)")) AS nom FROM utilisateurs WHERE LENGTH(mdp)=40 ORDER BY autorisation DESC, nom');
$a = 0;
$formulaire = '';
while ( $r = $resultat->fetch_assoc() )  {
  if ( $a != $r['autorisation'] )  {
    $a = $r['autorisation'];
    switch ( $a )  {
      case 1 : $t = 'Invités'; break;
      case 2 : $t = 'Élèves'; break;
      case 3 : $t = 'Colleurs'; break;
      case 4 : $t = 'Professeurs'; break;
    }
    $formulaire .= <<<FIN
    <!--<a class="icon-ajoute" title="Ajouter tous les $t"></a>
    <a class="icon-supprime" title="Retirer tous les $t"></a>-->
    <h4>$t</h4>

FIN;
  }
  // Pas d'identifiant sur les checkbox : ils seront rajoutés en javascript
  // après chargement dans #fenetre (sinon double id)
  $formulaire .= "    <p class=\"ligne\"><label for=\"u${r['id']}\">${r['nom']}</label> <input type=\"checkbox\" name=\"u${r['id']}\" class=\"a${r['autorisation']}\"></p>\n";
}

// Aide et formulaire d'ajout
?>

  <div id="form-utilisateurs">
    <h3>Modifier les utilisateurs en </h3>
<?php echo $formulaire; ?>
  </div>

  <form id="form-ajoute">
    <h3 class="edition">Ajouter une nouvelle matière</h3>
    <div>
      <input type="input" class="ligne" name="nom" value="" size="50" data-placeholder="Nom pour l'affichage (Commence par majuscule : Mathématiques, Physique...)">
      <input type="input" class="ligne" name="cle" value="" size="50" data-placeholder="Clé pour les adresses web (Diminutif en minuscules : maths, phys...)">
      <p class="ligne"><label for="colles_protection0">Accès aux programmes de colles&nbsp;: </label>
        <select id="colles_protection0" name="colles_protection"><?php echo $select_protection; ?>
        </select>
      </p>
      <p class="ligne"><label for="cdt_protection0">Accès au cahier de texte&nbsp;: </label>
        <select id="cdt_protection0" name="cdt_protection"><?php echo $select_protection; ?>
        </select>
      </p>
    </div>
    <input type="hidden" name="table" value="matieres">
  </form>

  <div id="aide-page">
    <h3>Aide et explications</h3>
    <p>Il est possible ici d'ajouter ou de modifier les matières utilisables sur le Cahier de Prépa.</p>
    <p>Seules les matières qui proposent un contenu (cahier de texte, programmes de colles, documents, notes) est visible dans le menu général. Cela est automatique.</p>
    <p>L'ordre d'apparition des matières dans le menu général est modifiable grâce aux boutons <span class="icon-monte"></span> et <span class="icon-descend"></span>.</p>
    <h4>Propriétés de chaque matière</h4>
    <p>Pour chaque matière associée à votre compte, vous pouvez modifier&nbsp;:</p>
    <ul>
      <li>le <em>nom complet</em> qui s'affiche dans le menu et dans les titres des pages. Mettez une majuscule au début.</li>
      <li>la <em>clé dans l'adresse</em> qui est un mot-clé utilisé uniquement dans l'adresse des pages associées à la matière. Il vaut mieux que ce soit un mot unique, court et sans majuscule. Par exemple, «&nbsp;maths&nbsp;», «&nbsp;phys&nbsp;»...</li>
    </ul>
    <p>L'<em>accès au programmes de colles</em> et l'<em>accès au cahier de texte</em> peuvent être choisis parmi cinq possibilités&nbsp;:</p>
    <ul>
      <li><em>Visible de tous</em>&nbsp;: accessible de tout visiteur, sans identification.</li>
      <li><em>Visible pour les connectés</em>&nbsp;: accessible de tout utilisateur mais uniquement après identification (compte invité, compte élève, compte colleur ou compte professeur).</li>
      <li><em>Visible pour les élèves, colleurs, professeurs</em>&nbsp;: accessible uniquement par les utilisateurs de types élève, colleur ou professeur. Il faut donc avoir un compte personnel validé (voir l'aide de la page <a href="utilisateurs">Utilisateurs</a>) pour y accéder.</li>
      <li><em>Visible pour les colleurs, professeurs</em>&nbsp;: accessible uniquement par les utilisateurs de type colleur ou professeur.</li>
      <li><em>Visible pour les professeurs</em>&nbsp;: accessible uniquement par les utilisateurs de type professeur (vous et vos collègues).</li>
    </ul>
    <p>Quel que soit ce choix, les liens dans le menu de la partie publique apparaîtront pour tout visiteur (si le cahier de texte/programme de colles est non vide uniquement), tout comme le lien vers les documents.</p>
    <p>Les modifications de nom, d'accès et les suppressions ne sont possibles que pour les matières qui vous sont associées. Vous pouvez modifier cela en cliquant sur le bouton <span class="icon-edite"></span> en bas de chaque matière, afin d'éditer la liste d'utilisateurs. Il est bien sûr possible d'être associé à plusieurs matières.</p>
    <h4>Suppressions massives</h4>
    <p>Pour les matières qui vous sont associées et s'il y en a, il est possible de supprimer en un seul coup les programmes de colles, le cahier de texte ou les documents. Des boutons larges apparaissent alors pour ce faire. Une confirmation sera demandée.</p>
    <p>Il est possible de complètement supprimer une matière en cliquant sur le bouton <span class="icon-supprime"></span> (une confirmation sera demandée). Cela entraîne&nbsp;:</p>
    <ul>
      <li>la suppression définitive des programmes de colles de cette matière</li>
      <li>la suppression définitive du cahier de texte de cette matière</li>
      <li>la suppression définitive des pages d'informations de cette matière</li>
      <li>la suppression définitive des notes de cette matière</li>
      <li>le déplacement virtuel du répertoire racine de la matière et de tous les documents qu'il contient au sein du répertoire Général, non associé à une matière.</li>
    </ul>
    <h4>Édition de la liste des utilisateurs</h4>
    <p>Pour chaque matière, il est possible d'éditer la liste des utilisateurs associés en cliquant sur le bouton <span class="icon-edite"></span> situé après le décompte global d'utilisateurs associés à la matière. Pour les comptes invités/élèves/colleurs, cela a une conséquence uniquement pour les contenus dont l'accès est restreint. Si l'accès d'un contenu est réglé à &laquo;&nbsp;<em>Visible pour les élèves, colleurs, professeurs</em>&nbsp;&raquo;, seuls les élèves et colleurs associés à la matière pourront y accéder.</p>
    <p>Les professeurs peuvent voir tous les contenus (même pour les matières qui ne leur sont pas associées) mais ne peuvent éditer que les matières qui leur sont associées.</p>
    <p>Les invités/élèves/colleurs ne peuvent pas changer seuls les matières qui leur sont associées.</p>
    <p>Tout compte doit être associé au minimum à une matière.</p>
  </div>

  <div id="aide-matiere">
    <h3>Aide et explications</h3>
    <h4>Édition des propriétés</h4>
    <p>Les modifications de nom, d'accès et les suppressions ne sont possibles que pour les matières qui vous sont associées. Vous pouvez modifier cela en cliquant sur le bouton <span class="icon-edite"></span> en bas de chaque matière, afin d'éditer la liste d'utilisateurs. Il est bien sûr possible d'être associé à plusieurs matières.</p>
    <p>Le <em>nom complet</em> est affiché dans le menu général et dans les titres des pages propres à la matières (cahier de texte, programmes de colles, documents, notes). Il doit commencer par une majuscule. Il peut être relativement long. Par exemple&nbsp;: «&nbsp;Mathématiques&nbsp;», «&nbsp;Sciences Physiques&nbsp;»...</p>
    <p>Le <em>nom</em> est aussi utilisé pour le répertoire situé à la racine des documents et contenant tous les documents de la matière.</p>
    <p>La <em>clé dans l'adresse</em> n'est lisible que dans les liens pointant vers ce Cahier de Prépa. Par convention, on préfère un mot tout en minuscules et court. Par exemple : «&nbsp;maths&nbsp;», «&nbsp;phys&nbsp;», «&nbsp;ph-ch&nbsp;», «&nbsp;frc&nbsp;»... La clé doit obligatoirement être unique (deux matières ne peuvent pas avoir la même clé).</p>
    <p>L'<em>accès aux programmes de colles</em> et l'<em>accès au cahier de texte</em> peuvent être choisis parmi cinq possibilités&nbsp;:</p>
    <ul>
      <li><em>Visible de tous</em>&nbsp;: accessible de tout visiteur, sans identification.</li>
      <li><em>Visible pour les connectés</em>&nbsp;: accessible de tout utilisateur mais uniquement après identification (compte invité, compte élève, compte colleur ou compte professeur).</li>
      <li><em>Visible pour les élèves, colleurs, professeurs</em>&nbsp;: accessible uniquement par les utilisateurs de types élève, colleur ou professeur. Il faut donc avoir un compte personnel validé (voir l'aide de la page <a href="utilisateurs">Utilisateurs</a>) pour y accéder.</li>
      <li><em>Visible pour les colleurs, professeurs</em>&nbsp;: accessible uniquement par les utilisateurs de type colleur ou professeur.</li>
      <li><em>Visible pour les professeurs</em>&nbsp;: accessible uniquement par les utilisateurs de type professeur (vous et vos collègues).</li>
    </ul>
    <p>Si ce choix n'est pas <em>Visible de tous</em>, les utilisateurs qui ne sont pas associés à cette matière n'ont pas accès aux pages correspondantes. Par exemple, si le programme de colles n'est visible que par les colleurs ou professeurs, alors les colleurs d'une autre matière n'y auront pas accès. Les professeurs ont eux accès à tout, mais ne peuvent éditer que les pages des matières qui leur sont associées.</p>
    <p>Quel que soit ce choix, les liens dans le menu de la partie publique apparaîtront pour tout visiteur (si le cahier de texte/programme de colles est non vide uniquement), tout comme le lien vers les documents.</p>
    <p>Pour les documents, le réglage de l'accès est propre à chaque répertoire, et ne se fait donc pas ici.</p>
    <h4>Déplacements et suppressions</h4>
    <p>D'autres modifications sont possibles à l'aide des boutons disponibles pour chaque matière&nbsp;:</p>
    <ul>
      <li><span class="icon-supprime"></span>&nbsp;: supprimer la matière (une confirmation sera demandée)</li>
      <li><span class="icon-monte"></span>&nbsp;: remonter la matière d'un cran dans le menu général</li>
      <li><span class="icon-descend"></span>&nbsp;: descendre le matière d'un cran dans le menu général</li>
    </ul>
    <p>Attention&nbsp;: supprimer une matière n'est pas sans conséquence&nbsp;: cela supprime aussi automatiquement le cahier de texte de la matière, tous les programmes de colles et toutes les notes de la matière, et les pages d'informations associées à la matière. Le répertoire contenant tous les documents n'est pas supprimé mais placé sans matière, comme simple sous-répertoire du répertoire Général.</p>
    <h4>Suppressions massives</h4>
    <p>Pour les matières qui vous sont associées et s'il y en a, il est possible de supprimer en un seul coup les programmes de colles, le cahier de texte ou les documents. Des boutons larges apparaissent alors pour ce faire. Une confirmation sera demandée.</p>
    <h4>Édition de la liste des utilisateurs</h4>
    <p>Pour chaque matière, il est possible d'éditer la liste des utilisateurs associés en cliquant sur le bouton <span class="icon-edite"></span> situé après le décompte global d'utilisateurs associés à la matière. Pour les comptes invités/élèves/colleurs, cela a une conséquence uniquement pour les contenus dont l'accès est restreint. Si l'accès d'un contenu est réglé à &laquo;&nbsp;<em>Visible pour les élèves, colleurs, professeurs</em>&nbsp;&raquo;, seuls les élèves et colleurs associés à la matière pourront y accéder.</p>
    <p>Les professeurs peuvent voir tous les contenus (même pour les matières qui ne leur sont pas associées) mais ne peuvent éditer que les matières qui leur sont associées.</p>
    <p>Les invités/élèves/colleurs ne peuvent pas changer seuls les matières qui leur sont associées.</p>
    <p>Tout compte doit être associé au minimum à une matière.</p>
  </div>

  <div id="aide-ajoute">
    <h3>Aide et explications</h3>
    <p>Ce formulaire permet de créer une nouvelle matière. Il sera validé par un clic sur <span class="icon-ok"></span>, et abandonné (donc supprimé) par un clic sur <span class="icon-ferme"></span>.</p>
    <p>Le <em>nom pour l'affichage</em> sera affiché dans le menu général et dans les titres des pages propres à la matières (cahier de texte, programmes de colles, documents, notes). Il doit commencer par une majuscule. Il peut être relativement long. Par exemple&nbsp;: «&nbsp;Mathématiques&nbsp;», «&nbsp;Sciences Physiques&nbsp;»...</p>
    <p>Le <em>nom</em> est aussi utilisé pour le répertoire situé à la racine des documents et contenant tous les documents de la matière.</p>
    <p>La <em>clé pour les adresses web</em> ne sera lisible que dans les liens pointant vers ce Cahier de Prépa. Par convention, on préfère un mot tout en minuscules et court. Par exemple : «&nbsp;maths&nbsp;», «&nbsp;phys&nbsp;», «&nbsp;ph-ch&nbsp;», «&nbsp;frc&nbsp;»... La clé doit obligatoirement être unique (deux matières ne peuvent pas avoir la même clé).</p>
    <p>L'<em>accès aux programmes de colles</em> et l'<em>accès au cahier de texte</em> peuvent être choisis parmi cinq possibilités&nbsp;:</p>
    <ul>
      <li><em>Visible de tous</em>&nbsp;: accessible de tout visiteur, sans identification.</li>
      <li><em>Visible pour les connectés</em>&nbsp;: accessible de tout utilisateur mais uniquement après identification (compte invité, compte élève, compte colleur ou compte professeur).</li>
      <li><em>Visible pour les élèves, colleurs, professeurs</em>&nbsp;: accessible uniquement par les utilisateurs de types élève, colleur ou professeur. Il faut donc avoir un compte personnel validé (voir l'aide de la page <a href="utilisateurs">Utilisateurs</a>) pour y accéder.</li>
      <li><em>Visible pour les colleurs, professeurs</em>&nbsp;: accessible uniquement par les utilisateurs de type colleur ou professeur.</li>
      <li><em>Visible pour les professeurs</em>&nbsp;: accessible uniquement par les utilisateurs de type professeur (vous et vos collègues).</li>
    </ul>
    <p>Si ce choix n'est pas <em>Visible de tous</em>, les utilisateurs qui ne sont pas associés à cette matière n'ont pas accès aux pages correspondantes. Par exemple, si le programme de colles n'est visible que par les colleurs ou professeurs, alors les colleurs d'une autre matière n'y auront pas accès. Les professeurs ont eux accès à tout, mais ne peuvent éditer que les pages des matières qui leur sont associées.</p>
    <p>Quel que soit ce choix, les liens dans le menu de la partie publique apparaîtront pour tout visiteur (si le cahier de texte/programme de colles est non vide uniquement), tout comme le lien vers les documents.</p>
    <p>Pour les documents, le réglage de l'accès est propre à chaque répertoire, et ne se fait donc pas ici.</p>
    <p>La nouvelle matière sera automatiquement associée à tous les comptes utilisateurs qui peuvent déjà avoir accès à toutes les matières (en général, les élèves). Pour les autres comptes, il faudra éditer la liste d'utilisateurs une fois la matière enregistrée.</p>
  </div>

  <p id="log"></p>
  
  <script type="text/javascript">
$( function() {
  // Envoi par appui sur Entrée
  $('input,select').on('keypress',function (e) {
    if ( e.which == 13 )
      $(this).parent().parent().children('a.icon-ok').click();
  });
});
  </script>
<?php

$mysqli->close();
fin(true);
?>
