<?php
// Sécurité
define('OK',1);
// Configuration
include('config.php');
// Fonctions
include('fonctions.php');

//////////////////
// Autorisation //
//////////////////

// Accès aux professeurs connectés uniquement
$mysqli = connectsql();
if ( !$autorisation )  {
  $titre = 'Pages';
  $actuel = false;
  include('login.php');
}
elseif ( $autorisation < 4 )  {
  debut($mysqli,'Pages','Vous n\'avez pas accès à cette page.',$autorisation,' ');
  $mysqli->close();
  fin();
}

//////////////
//// HTML ////
//////////////
debut($mysqli,'Modification des pages',$message,4,'pages');
echo <<<FIN

  <a class="icon-aide general" data-id="page" title="Aide pour les modifications des pages"></a>
  <a class="icon-ajoute general" data-id="ajoute" title="Ajouter une nouvelle page"></a>

FIN;
$select_protection = '
        <option value="0">Visible de tous</option>
        <option value="1">Visible pour les connectés</option>
        <option value="2">Visible pour les élèves, colleurs, profs</option>
        <option value="3">Visible pour les colleurs et les profs</option>
        <option value="4">Visible pour les profs uniquement</option>';


// Récupération des matières
$select_matieres = '<option value="0">Pas de matière associée</option>';
$resultat = $mysqli->query("SELECT id, nom FROM matieres WHERE FIND_IN_SET(id,'${_SESSION['matieres']}') ORDER BY ordre");
while ( $r = $resultat->fetch_assoc() )
  $select_matieres .= "<option value=\"${r['id']}\">${r['nom']}</option>";
$resultat->free();

// Récupération des pages
$resultat = $mysqli->query("SELECT IFNULL(m.id,0) AS id, m.nom, MAX(p.ordre) AS max
                            FROM pages AS p LEFT JOIN matieres AS m ON p.mat = m.id
                            WHERE FIND_IN_SET(p.mat,'${_SESSION['matieres']}') GROUP BY m.id ORDER BY m.ordre");
while ( $m = $resultat->fetch_assoc() )  {
  if ( $m['id'] )
    echo "<h3>${m['nom']}</h3>\n\n";
  $resultat1 = $mysqli->query("SELECT p.id, p.ordre, p.cle, p.nom, p.mat, p.titre, p.bandeau, p.protection, COUNT(i.id) AS n
                              FROM pages AS p LEFT JOIN infos AS i ON i.page = p.id WHERE p.mat = ${m['id']} GROUP BY p.id ORDER BY p.ordre");
  while ( $r = $resultat1->fetch_assoc() )  {
    $id = $r['id'];
    $monte = ( ( $r['ordre'] == 1 ) || ( !$m['id'] && ( $r['ordre'] == 2 ) ) ) ? ' style="display:none;"' : '';
    $descend = ( ( $r['ordre'] == $m['max'] ) || ( $r['id'] == 1 ) ) ? ' style="display:none;"' : '';
    $sel_matiere = str_replace("\"${m['id']}\"","\"${m['id']}\" selected",$select_matieres);
    $sel_protection = str_replace("\"${r['protection']}\"","\"${r['protection']}\" selected",$select_protection);
    $suppr = ( $r['id'] > 1 ) ? "\n  <a class=\"icon-supprime\" title=\"Supprimer cette page\"></a>" : '';
    $nom = ( $m['id'] ) ? "${m['nom']}/${r['nom']}" : $r['nom'];
    if ( $r['id'] > 1 )  {
      $suppr = "\n  <a class=\"icon-supprime\" title=\"Supprimer cette page\"></a>";
      str_replace("\"${m['id']}\"","\"${m['id']}\" selected",$select_matieres);
      $sel_matiere = <<<FIN

    <p class="ligne"><label for="matiere$id">Matière&nbsp;: </label>
      <select id="matiere$id" name="matiere">
        $sel_matiere
      </select>
    </p>
FIN;
      $span = '';
    }
    else  {
      $suppr = $sel_matiere = '';
      // Pour obtenir le bon comportement du script js lors après les montées/descentes
      $span = '<span></span>';
    }
    $supprinfos = ( $r['n'] ) ? "\n    <input type=\"button\" class=\"ligne supprmultiple\" data-id=\"pages|$id|infos\" value=\"Supprimer les ${r['n']} informations de la page\">" : '';
    echo <<<FIN

<article data-id="pages|$id">
  <a class="icon-monte"$monte title="Déplacer cette matière vers le haut"></a>
  <a class="icon-descend"$descend title="Déplacer cette matière vers le bas"></a>$suppr
  <form>
    <a class="icon-ok" title="Valider les modifications"></a>
    <h3 class="edition">$nom</h3>
    <p class="ligne"><label for="titre$id">Titre&nbsp;: </label><input type="text" id="titre$id" name="titre" value="${r['titre']}" size="50" data-placeholder="Ex: «&nbsp;Informations en [matière]&nbsp;», «&nbsp;À propos de l'ADS et du TIPE&nbsp;»"></p>
    <p class="ligne"><label for="nom$id">Nom dans le menu&nbsp;: </label><input type="text" id="nom$id" name="nom" value="${r['nom']}" size="50" data-placeholder="Pas trop long. Ex: «&nbsp;Informations&nbsp;», «&nbsp;Informations ADS/TIPE&nbsp;»"></p>
    <p class="ligne"><label for="cle$id">Clé dans l'adresse&nbsp;: </label><input type="text" id="cle$id" name="cle" value="${r['cle']}" size="30" data-placeholder="En minuscules et sans espace. Ex: «&nbsp;infos&nbsp;», «&nbsp;ads-tipe&nbsp;»"></p>$sel_matiere
    <p class="ligne"><label for="protection$id">Accès&nbsp;: </label>
      <select id="protection$id" name="protection">$sel_protection
      </select>
    </p>
    <p class="ligne"><label for="bandeau$id">Texte de début&nbsp;:</label></p>
    <textarea id="bandeau$id" name="bandeau" rows="2" cols="100" data-placeholder="Texte qui s'affichera au début de la page">${r['bandeau']}</textarea>$supprinfos
  </form>
</article>
$span
FIN;
  }
  $resultat1->free();
}
$resultat->free();

// Aide et formulaire d'ajout
?>

  <form id="form-ajoute">
    <h3 class="edition">Ajouter une nouvelle page</h3>
    <div>
      <input type="text" class="ligne"  id="nom" name="nom" value="" size="50" data-placeholder="Nom pour le menu. Pas trop long. Ex: «&nbsp;Informations&nbsp;», «&nbsp;Informations ADS/TIPE&nbsp;»">
      <input type="text" class="ligne" id="cle" name="cle" value="" size="30" data-placeholder="Clé pour l''adresse web. En minuscules et sans espace. Ex: «&nbsp;infos&nbsp;», «&nbsp;ads-tipe&nbsp;»">
      <input type="text" class="ligne" id="titre" name="titre" value="" size="50" data-placeholder="Titre. Ex: «&nbsp;Informations en [matière]&nbsp;», «&nbsp;À propos de l'ADS et du TIPE&nbsp;»">
      <p class="ligne"><label for="matiere$id">Matière&nbsp;: </label>
        <select id="matiere" name="matiere">
          <?php echo $select_matieres; ?>
        </select>
      </p>
      <p class="ligne"><label for="protection">Accès&nbsp;: </label>
        <select id="protection" name="protection"><?php echo $select_protection; ?>
        </select>
      </p>
      <p class="ligne"><label for="bandeau">Texte de début&nbsp;:</label></p>
      <textarea id="bandeau" name="bandeau" rows="2" cols="100" data-placeholder="Texte qui s'affichera au début de la page"></textarea>
      <input type="hidden" name="table" value="pages">
    </div>
  </form>

  <div id="aide-page">
    <h3>Aide et explications</h3>
    <p>À venir bientôt...</p>
  </div>

  <div id="aide-ajoute">
    <h3>Aide et explications</h3>
    <p>À venir bientôt...</p>
  </div>

  <p id="log"></p>
  
  <script type="text/javascript">
$( function() {
  // Défaut sur le bandeau
  $('[name="bandeau"]').placeholder();
  // Envoi par appui sur Entrée
  $('input,select').on('keypress',function (e) {
    if ( e.which == 13 )
      $(this).parent().parent().children('a.icon-ok').click();
  });
});
  </script>
<?php

$mysqli->close();
fin(true);
?>
