<?php
// Sécurité
define('OK',1);
// Configuration
include('config.php');
// Fonctions
include('fonctions.php');

//////////////////
// Autorisation //
//////////////////

// Accès aux professeurs connectés uniquement
$mysqli = connectsql();
if ( !$autorisation )  {
  $titre = 'Planning';
  $actuel = false;
  include('login.php');
}
elseif ( $autorisation < 4 )  {
  debut($mysqli,'Planning','Vous n\'avez pas accès à cette page.',$autorisation,' ');
  $mysqli->close();
  fin();
}

//////////////
//// HTML ////
//////////////
debut($mysqli,'Modication du planning',$message,4,'planning');
echo <<<FIN

  <a class="icon-aide general" data-id="page" title="Aide pour les modifications du planning"></a>
  <a class="icon-ok general" title="Valider les modifications du planning" data-noreload=""></a>

  <article>
    <h3>Liste des semaines</h3>
    <form>
      <table id="planning">
        <thead>
          <tr>
            <th>Début de semaine</th>
            <th>Colle ou non</th>
            <th>Vacances</th>
          </tr>
        </thead>
        <tbody>

FIN;

// Récupération et affichage des matières
$semaine = array('Dimanche','Lundi','Mardi','Mercredi','Jeudi','Vendredi','Samedi');
$resultat = $mysqli->query('SELECT id, DATE_FORMAT(debut,\'%w\') AS jour, DATE_FORMAT(debut,\'%d/%m/%Y\') AS debut, IF(colle=1,\' checked\',\'\') AS colle, vacances FROM semaines');
while ( $r = $resultat->fetch_assoc() )  {
  $select = str_replace("\"${r['vacances']}\"","\"${r['vacances']}\" selected",'<option value="0">Période scolaire</option><option value="1">Vacances de Toussaint</option><option value="2">Vacances de Noël</option><option value="3">Vacances d\'hiver</option><option value="4">Vacances de printemps</option>');
  $r['jour'] = $semaine[$r['jour']];
  echo <<<FIN
          <tr>
            <td>${r['jour']} ${r['debut']}</td>
            <td><input type="checkbox" name="colles[${r['id']}]" value="1"${r['colle']}></td>
            <td><select name="vacances[${r['id']}]">$select</select></td>
          </tr>

FIN;
}
$resultat->free();

// Fin du formulaire
?>
        </tbody>
      </table>
      <input type="hidden" name="table" value="semaines">
    </form>
  </article>

  <script type="text/javascript">
$( function() {
  $('select').change(function () {
    if ( $(this).val() == 0 )  {
      $(this).parent().prev().children('input').prop('checked',true);
    }
    else  {
      $(this).parent().prev().children('input').prop('checked',false);
    }
  });
  $('input:checkbox').change(function () {
    if ( $(this).is(':checked') )  {
      $(this).parent().next().children('select').val(0);
    }
  });
});
  </script>

  
  <div id="aide-page">
    <h3>Aide et explications</h3>
    <p>Il est possible ici de modifier le planning annuel, c'est-à-dire pour chaque semaine de l'année, préciser s'il s'agit&nbsp;:
    <ul>
      <li>d'une semaine de colle (case <em>Colle ou non</em> cochée), qui pourra recevoir des programmes de colles et des notes de colles.</li>
      <li>d'une semaine sans colle (case <em>Colle ou non</em> décochée), qui ne pourra recevoir ni programmes de colles, ni notes de colles.</li>
      <li>d'une semaine de vacances (colonne <em>Vacances</em>) qui ne pourra recevoir ni cahier de texte, ni programmes de colles, ni notes de colles.</li>
    </ul>
    <p>Les vacances de deux semaines (toutes en fait :-) ) sont donc à marquer deux fois.</p>
    <p>Il est préférable de décocher la case <em>Colle ou non</em> lorsque l'on sait qu'il n'y aura pas de colle, comme souvent en début ou en fin d'année&nbsp;: cela modifie l'affichage des programmes de colles (&laquo;&nbsp;Il n'y a pas de colle cette semaine&nbsp;&raquo; au lieu de &laquo;&nbsp;Le programme de colles de cette semaine n'est pas défini.&nbsp;&raquo;), et évite les erreurs d'écriture des programmes.</p>
  </div>

  <p id="log"></p>
  
<?php

$mysqli->close();
fin(true);
?>
