<?php
// Sécurité
define('OK',1);
// Configuration
include('config.php');
// Fonctions
include('fonctions.php');

//////////////////
// Autorisation //
//////////////////

// Accès aux professeurs, colleurs, élèves connectés uniquement
$mysqli = connectsql();
if ( !$autorisation )  {
  $titre = 'Préférences';
  $actuel = false;
  include('login.php');
}
elseif ( $autorisation < 2 )  {
  debut($mysqli,'Préférences','Vous n\'avez pas accès à cette page.',$autorisation,' ');
  $mysqli->close();
  fin();
}

//////////////
//// HTML ////
//////////////
debut($mysqli,'Mon compte',$message,$autorisation,'prefs');

// Récupération des données de l'utilisateur
$resultat = $mysqli->query("SELECT login, nom, prenom, mail, mdp, matieres, timeout FROM utilisateurs WHERE id = ${_SESSION['id']}");
$r = $resultat->fetch_assoc();
$resultat->free();

?>

  <a class="icon-aide general" data-id="page" title="Aide pour les modifications de vos préférences"></a>

  <article data-id="aucune|0">
    <form>
      <a class="icon-ok" title="Valider les modifications" data-noreload=""></a>
      <h3 class="edition">Mon identité</h3>
      <p class="ligne"><label for="prenom">Prénom&nbsp;: </label><input type="text" id="prenom" name="prenom" value="<?php echo $r['prenom']; ?>" size="50"></p>
      <p class="ligne"><label for="nom">Nom&nbsp;: </label><input type="text" id="nom" name="nom" value="<?php echo $r['nom']; ?>" size="50"></p>
      <p class="ligne"><label for="mail1">Adresse mail&nbsp;: </label><input type="text" id="mail1" name="mail1" value="<?php echo $r['mail']; ?>" size="50"></p>
      <p class="ligne"><label for="mail2">Confirmation&nbsp;: </label><input type="text" id="mail2" name="mail2" value="" size="50"></p>
      <p class="ligne"><label for="mdp0">Mot de passe&nbsp;: </label><input type="password" id="mdp0" name="mdp" value=""></p>
      <p>Le mot de passe actuel doit être obligatoirement fourni pour toute modification.</p>
      <input type="hidden" name="prefs" value="">
    </form>
  </article>

  <article data-id="prefs|moi">
    <form>
      <a class="icon-ok" title="Valider les modifications" data-noreload=""></a>
      <h3 class="edition">Ma connexion</h3>
      <p class="ligne"><label for="login">Identifiant&nbsp;: </label><input type="text" id="login" name="login" value="<?php echo $r['login']; ?>" size="50"></p>
      <p class="ligne"><label for="mdp1">Nouveau mot de passe&nbsp;: </label><input type="password" id="mdp1" name="mdp1" value=""></p>
      <p class="ligne"><label for="mdp2">Confirmation&nbsp;: </label><input type="password" id="mdp2" name="mdp2" value=""></p>
      <p class="ligne"><label for="timeout">Durée avant déconnexion&nbsp;: </label><input type="text" id="timeout" name="timeout" value="<?php echo $r['timeout']; ?>" size="3"></p>
      <p class="ligne"><label for="mdp00">Mot de passe actuel&nbsp;: </label><input type="password" id="mdp00" name="mdp" value=""></p>
      <p>Le mot de passe actuel doit être obligatoirement fourni pour toute modification.</p>
      <input type="hidden" name="prefs" value="">
    </form>
  </article>

  <div id="aide-page">
    <h3>Aide et explications</h3>
    <p>Il est possible ici de modifier vos préférences. Une fois modifié, le formulaire est à validé par un clic sur le bouton <span class="icon-ok"></span>.</p>
    <h4>Modification de l'identité&nbsp;: nom, prénom, adresse mail</h4>
    <p>Si l'on souhaite modifier l'adresse mail, il faut la saisir deux fois afin d'éviter les fautes de frappes.</p>
    <p>Afin d'éviter les usurpations de compte, il est nécessaire de taper son mot de passe pour toute modification.</p>
    <p>L'adresse mail ne sera pas modifiée si un autre compte contient déjà la nouvelle valeur saisie.</p>
    <p>Il est possible de ne modifier que le prénom ou le nom sans modifier l'adresse mail&nbsp;: il n'est alors pas nécessaire de saisir une deuxième fois l'adresse mail.</p>
    <p>L'adresse mail sert pour les élèves à recevoir des mails de la part des professeurs et colleurs. Pour les colleurs et professeurs, cela permet de recevoir et d'envoyer des mails via ce Cahier de Prépa.</p>
    <h4>Modification des paramètres de connexion</h4>
    <p>Votre identifiant est initialement de la forme &laquo;&nbsp;jdupont&nbsp;&raquo;. Vous pouvez le modifier, à condition de ne pas demander un identifiant déjà existant dans la base.</p>
    <p>Si l'on souhaite modifier le mot de passe, il faut le saisir deux fois afin d'éviter les fautes de frappes.</p>
    <p>La <em>durée avant connexion</em> est la durée en secondes au bout de laquelle votre session sera effacée sur le serveur, et une reconnexion sera nécessaire. C'est une sécurité si vous oubliez de vous déconnecter alors que vous êtes sur un ordinateur publique. La valeur par défaut est 900s, soit 15 minutes.</p>
    <p>Afin d'éviter les usurpations de compte, il est nécessaire de taper son mot de passe pour toute modification.</p>
  </div>

  <p id="log"></p>
  
  <script type="text/javascript">
$( function() {
  // Envoi par appui sur Entrée
  $('input').on('keypress',function (e) {
    if ( e.which == 13 )
      $(this).parent().parent().children('a.icon-ok').click();
  });
});
  </script>
<?php

$mysqli->close();
fin(true);
?>
